/********************************
*				*
*	Support Program		*
*				*
********************************/



#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <seccomp.h>



/* MAIN */
int main () {
	scmp_filter_ctx seccomp_ctx;
	char *argv [] = {"./vulnerable_program", NULL};
	char *envp [] = {NULL};

	/* Inizializza la Libreria Seccomp (per la Creazione di una Whitelist) */
	if ((seccomp_ctx = seccomp_init (SCMP_ACT_KILL)) == NULL) {
		perror ("[ERRORE_init]");
		return 0;
	}

	/* Definisci le Regole di Filtraggio */
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (execve), 1, SCMP_A1 (SCMP_CMP_EQ, (scmp_datum_t) argv)) < 0) {
		perror ("[ERRORE_add_execve]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (brk), 0) < 0) {
		perror ("[ERRORE_add_brk]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (access), 0) < 0) {
		perror ("[ERRORE_add_access]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (openat), 0) < 0) {
		perror ("[ERRORE_add_openat]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (mmap), 0) < 0) {
		perror ("[ERRORE_add_mmap]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (close), 0) < 0) {
		perror ("[ERRORE_add_close]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (mprotect), 0) < 0) {
		perror ("[ERRORE_add_mprotect]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (arch_prctl), 0) < 0) {
		perror ("[ERRORE_add_prctl]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (munmap), 0) < 0) {
		perror ("[ERRORE_add_munmap]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (fstat), 0) < 0) {
		perror ("[ERRORE_add_fstat]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (write), 0) < 0) {
		perror ("[ERRORE_add_write]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (read), 0) < 0) {
		perror ("[ERRORE_add_read]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (lseek), 0) < 0) {
		perror ("[ERRORE_add_lseek]");
		return 0;
	}
	if (seccomp_rule_add (seccomp_ctx, SCMP_ACT_ALLOW, SCMP_SYS (exit_group), 0) < 0) {
		perror ("[ERRORE_add_exit]");
		return 0;
	}

	/* Carica il Filtro Creato nel Kernel */
	if (seccomp_load (seccomp_ctx) < 0) {
		perror ("[ERRORE_load]");
		return 0;
	}

	/* Esegui Programma da Controllare */
	execve (argv [0], argv, envp);

	return 0;
}
