# Esegui il Backup della Configurazione del Load Balancer #
exec { "load_balancer_backup":
	command => "cp ${pwd}/load_balancer/haproxy.cfg ${pwd}/load_balancer/haproxy_bkp.cfg",
	path => "${system_path}"
}

# Esegui 3 Nuovi Server #
["web_server", "web_server", "web_server"].each |Integer $index, String $value| {
	$n = $index + 3
	docker::run { "${value}${n}":
		image => "${value}",
		volumes => ["${pwd}/web_server/source:/var/www/html", "${pwd}/web_server/waf_rules:/usr/share/modsecurity-crs/rules"],
		name => ["web-server${n}"],
		labels => ["id=${value}"],
		net => "cilium-net",
		extra_parameters => ["--rm"],
		before => Exec["${value}${n}_update"]
	}
	# Aggiorna la Configurazione del Load Balancer
	exec { "${value}${n}_update":
		command => "echo -e '\tserver ${value}${n} web-server${n}:80 check inter 10s resolvers dns' >> ${pwd}/load_balancer/haproxy.cfg",
		path => "${system_path}",
		before => Exec["load_balancer_restart"]
	}
}

# Riavvia il Load Balancer #
exec { "load_balancer_restart":
	command => "sleep 15; docker restart load-balancer",
	path => "${system_path}",
	before => Exec["load_balancer_routing_update"]
}

# Aggiorna le Regole di Routing associate al Load Balancer #
exec { "load_balancer_routing_update":
	command => "sleep 3; load_balancer_ip=$(docker inspect load-balancer | grep -E \"\\\"IPAddress\\\": \\\"[0-9].*\\\"\" | cut -d '\"' -f 4); iptables -t nat -D PREROUTING 1; iptables -t nat -D OUTPUT 1; iptables -t nat -I PREROUTING -p tcp --dport 80 -j DNAT --to \$load_balancer_ip:80; iptables -t nat -I OUTPUT -p tcp --dport 80 -o lo -j DNAT --to \$load_balancer_ip:80",
	path => "${system_path}"
}
