##### LIVELLO_PULIZIA_0 ##### (Non cambiare/cancellare questa riga!)

# Ferma tutti i Container & Disabilita i Servizi Associati #
["web_server", "web_server", "web_server"].each |Integer $index, String $value| {
	docker::run { "${value}${index}":
		image => "web_server",
		ensure => absent,
		before => Exec["wait"]
	}
}
docker::run { 'web_server_db':
	image => "web_server_db",
	ensure => absent,
	before => Exec["wait"]
}
docker::run { 'web_server_admin':
	image => "web_server_admin",
	ensure => absent,
	before => Exec["wait"]
}
docker::run { 'load_balancer':
	image => "load_balancer",
	ensure => absent,
	before => Exec["wait"]
}
exec { 'wait':
	command => "sleep 5",
	path => "${system_path}"
}
exec { 'cilium-net':
	command => "docker network rm cilium-net || :",
	path => "${system_path}",
	require => Exec["wait"]
}
docker_compose { "${pwd}/cilium/docker-compose.yml":
        ensure => absent,
	require => Exec["wait"]
}
exec { 'cilium_default':
	command => "docker network rm cilium_default || :",
	path => "${system_path}",
	require => Exec["wait"]
}



##### LIVELLO_PULIZIA_1 ##### (Non cambiare/cancellare questa riga!)

# Rimuovi Anche le Immagini Finali e Ripulisci i File di Log #
docker::image { 'web_server':
	ensure => absent
}
docker::image { 'web_server_db':
	ensure => absent
}
docker::image { 'web_server_admin':
	ensure => absent
}
exec { 'clean_logs':
	command => "rm -r ${pwd}/logs/web_server*/* ${pwd}/logs/firewall*.log || :",
	path => "${system_path}"
}



##### LIVELLO_PULIZIA_2 ###### (Non cambiare/cancellare questa riga!)

# Rimuovi Anche le Immagini Sorgente #
docker::image { 'php':
	image_tag => "apache",
	ensure => absent
}
docker::image { 'mysql/mysql-server':
	image_tag => "5.7",
	ensure => absent
}
docker::image { 'ubuntu':
	image_tag => "16.04",
	ensure => absent
}
docker::image { 'haproxy':
	ensure => absent
}
docker::image { 'cilium/cilium':
	image_tag => "stable",
	ensure => absent
}
docker::image { 'consul':
	image_tag => "0.8.3",
	ensure => absent
}
